//  ARDUINO + L298N + SWITCH
#include<Wire.h>
const int MPU_addr1 = 0x68;
float xa, ya, za, roll, pitch, gyroX, gyroY;

const int enA = 11;
const int X1 = 10;
const int X2 = 9;

const int enB = 6;
const int Y1 = 7;
const int Y2 = 8;


const int Xup =  5;
const int Xdown = 4;      // the number of the LED pin

const int Yup =  3;
const int Ydown = 2;      // the number of the LED pin

int switchX;
int switchY;


int Xa;
int Xb;
int Ya;
int Yb;
// variables will change:


void setup() {

  Wire.begin();                                      //begin the wire communication
  Wire.beginTransmission(MPU_addr1);                 //begin, send the slave adress (in this case 68)
  Wire.write(0x6B);                                  //make the reset (place a 0 into the 6B register)
  Wire.write(0);
  Wire.endTransmission(true);                        //end the transmission
  Serial.begin(9600);
  
  // initialize the LED pin as an output:
  pinMode(enA, OUTPUT);
  pinMode(X1, OUTPUT);
  pinMode(X2, OUTPUT);
  
  pinMode(enB, OUTPUT);
  pinMode(Y1, OUTPUT);
  pinMode(Y2, OUTPUT);
  
  // initialize the pushbutton pin as an input:
  pinMode(Xup, INPUT);
  pinMode(Xdown, INPUT);

  pinMode(Yup, INPUT);
  pinMode(Ydown, INPUT);

  digitalWrite(X1, LOW);
  digitalWrite(X2, LOW);
  digitalWrite(Y1, LOW);
  digitalWrite(Y2, LOW);


}

void loop() {

//Sensor MPU6050
  Wire.beginTransmission(MPU_addr1);
  Wire.write(0x3B);
  Wire.endTransmission(false);
  Wire.requestFrom(MPU_addr1, 6, true); //get six bytes accelerometer data

  xa = Wire.read() << 8 | Wire.read();
  ya = Wire.read() << 8 | Wire.read();
  za = Wire.read() << 8 | Wire.read();

  roll = atan2(ya , za) * 180.0 / PI;
  pitch = atan2(-xa , sqrt(ya * ya + za * za)) * 180.0 / PI;

  gyroX = pitch;
  gyroY = roll ;
  
  Serial.print("sumbu X = ");
  Serial.print(gyroX,1);
  Serial.println(;);
  Serial.print(", sumbu Y = ");
  Serial.println(gyroY,1);


if (gyroX >= 3){ 
          analogWrite(enA, 255);        
      }
   else if ( 1 <= gyroX <= 3 ) {
          analogWrite(enA, 150);        
      } 

   else if ( -1 <= gyroX <= 1 ) {
          analogWrite(enA, 0);        
      } 
   else if ( -3 <= gyroX <= -1 ) {
          analogWrite(enA, 125);        
      }    
   else if ( gyroX <= -3 ) {
          analogWrite(enA, 255);        
      } 


 if (gyroY >= 3){ 
          analogWrite(enB, 255);        
      }
   else if ( 1 <= gyroY <= 3 ) {
          analogWrite(enB, 150);        
      } 
   else if ( -1 <= gyroY <= 1 ) {
          analogWrite(enB, 0);        
      } 
   else if ( -3 <= gyroY <= -1 ) {
          analogWrite(enB, 125);        
      }    
   else if ( gyroY <= -3 ) {
          analogWrite(enB, 255);        
      } 
  
  
// Membaca input ush button
  Xa = digitalRead(Xup);
  Xb = digitalRead(Xdown);
  
  Ya = digitalRead(Yup);
  Yb = digitalRead(Ydown);

// Perintah untuk menggerakkan aktuator (push button)   
  if (Xa == HIGH) {
    digitalWrite(X1, HIGH);
    digitalWrite(X2, LOW);
    delay(20);
    digitalWrite(X1, LOW);
    digitalWrite(X2, LOW);
  } else if ((Xb == HIGH)) {
    digitalWrite(X1, LOW);
    digitalWrite(X2, HIGH);
    delay(20);
    digitalWrite(X1, LOW);
    digitalWrite(X2, LOW);
  }

  if (Ya == HIGH) {
    digitalWrite(Y1, HIGH);
    digitalWrite(Y2, LOW);
    delay(20);
    digitalWrite(Y1, LOW);
    digitalWrite(Y2, LOW);
  } else if ((Yb == HIGH)) {
    digitalWrite(Y1, LOW);
    digitalWrite(Y2, HIGH);
    delay(20);
    digitalWrite(Y1, LOW);
    digitalWrite(Y2, LOW);
  } 



// Perintah untuk menggerakkan aktuator (bluetooth)   
  while(Serial.available()>0)
     {          
      char value = Serial.read(); // reading the data received from the bluetooth module
      Serial.println (value);
      if (value == '1'){
          digitalWrite(X1, LOW);
          digitalWrite(X2, HIGH);;          
      }
      if (value == '2'){ 
          digitalWrite(X1, HIGH);
          digitalWrite(X2, LOW);           
      }       
      if (value == 'a'){ 
          digitalWrite(X1, LOW);
          digitalWrite(X2, LOW);
      }
      if (value == '3'){ 
          digitalWrite(Y1, HIGH);
          digitalWrite(Y2, LOW);
      }
      if (value == '4'){ 
          digitalWrite(Y1, LOW);
          digitalWrite(Y2, HIGH);
      }
      if (value == 'b'){ 
          digitalWrite(Y1, LOW); 
          digitalWrite(Y2,LOW);
      }
      }
   }
  
 
//nilai tegangan switch ldr : (700/1023) * 5 VDC = 3,42 VDC


void sumbuX() {
 if (gyroX >= 3){ 
          analogWrite(enA, 255);        
      }
   else if ( 1 <= gyroX <= 3 ) {
          analogWrite(enA, 150);        
      } 

   else if ( -1 <= gyroX <= 1 ) {
          analogWrite(enA, 0);        
      } 
   else if ( -3 <= gyroX <= -1 ) {
          analogWrite(enA, 125);        
      }    
   else if ( gyroX <= -3 ) {
          analogWrite(enA, 255);        
      } 
}


void sumbuY() {
 if (gyroY >= 3){ 
          analogWrite(enB, 255);        
      }
   else if ( 1 <= gyroY <= 3 ) {
          analogWrite(enB, 150);        
      } 
   else if ( -1 <= gyroY <= 1 ) {
          analogWrite(enB, 0);        
      } 
   else if ( -3 <= gyroY <= -1 ) {
          analogWrite(enB, 125);        
      }    
   else if ( gyroY <= -3 ) {
          analogWrite(enB, 255);        
      } 
}
